<template src="./template.html"></template>

<script lang="ts">
import {
  Component,
  getModule,
  Prop,
  Vue,
  Watch,
} from "nuxt-property-decorator";
import { api } from "~/common/constaint";
import UserModule from "~/store/user";
import { redirectPage } from "~/utils/apiHanlers";
import { apiErrorHandler } from "~/utils/apiHanlers";
@Component({})
export default class ListProductAdminComponent extends Vue {
  page = 1;
  get listProductAdmin() {
    return this.$store.state.sellerStore.listProductAdmin;
  }

  set listProductAdmin(value: boolean) {
    this.$store.commit("sellerStore/setListProductAdmin", value);
  }
  tempProduct: any = {};
  productList = [];
  config = {
    page: 1,
    limit: 24,
    search: "",
    priceFrom: "",
    priceTo: "",
    productCostFrom: "",
    productCostTo: "",
  };
  domains = [];
  createStore = {
    storeName: "",
    domain: "",
    productId: "",
    supportEmail: "",
  };
  subDomain = "";
  totalPage: number = 1;
  domain: any = {};
  searchNameValue = "";
  loading = false;

  async onSelectDomain(domain: any) {
    await this.onCheckDomain();
    const findDomain = this.domains.find(
      (itemCheckDomain: any) => itemCheckDomain.domain === domain
    );
    if (findDomain) {
      this.domain = findDomain;
    } else {
      this.domain = {};
    }
  }

  viewSite(id: any) {
    const tempProduct: any = this.productList.find(
      (item: any) => item.id === id
    );
    if (tempProduct) {
      this.tempProduct = tempProduct;
      this.$router.push(`/seller/products/preview/${tempProduct._id}`);
    }
  }

  onOpenDialog(id: any) {
    this.listProductAdmin = true;
    const tempProduct: any = this.productList.find(
      (item: any) => item.id === id
    );
    if (tempProduct) {
      this.tempProduct = tempProduct;
      this.isDomainNotExist = false;
      // this.createStore.domain = tempProduct.slug;
    }
  }
  isDomainExist = false;
  isDomainNotExist = false;
  loadingCheckDomain = false;
  async onCheckDomain() {
    try {
      this.isDomainExist = false;
      this.isDomainNotExist = false;
      if (!this.createStore.domain || !this.subDomain) return;
      this.loadingCheckDomain = true;
      await this.$api.store.sellerStoreCheckDomain({
        domain: this.createStore.domain + "." + this.subDomain,
      });
      this.isDomainNotExist = true;
    } catch (error) {
      this.isDomainExist = true;
      // apiErrorHandler(error, this);
    } finally {
      this.loadingCheckDomain = false;
    }
  }

  onCloseDialog() {
    this.listProductAdmin = false;
  }
  convertImage(url: string) {
    return `${api}/${url}`;
  }

  loadingPage = false;

  async onGetProductList() {
    try {
      this.loadingPage = true;
      let query = {
        ...this.config,
        search: this.searchNameValue || this.config.search,
      };
      const res = await this.$api.productSeller.list(query);
      if (res?.data) {
        const { total } = res.data;
        this.totalPage = Math.ceil(total / this.config.limit);
        this.productList = res.data.data;
        this.$store.commit("sellerStore/setProductList", res.data.data);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingPage = false;
    }
  }
  async onGetDomain() {
    try {
      let query = {
        ...this.config,
      };
      const res = await this.$api.domainSeller.list(query);
      if (res?.data) {
        this.domains = res?.data?.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  isErrorDomainName = false;

  async onCreateStore() {
    try {
      this.isErrorDomainName = false;
      if (!this.createStore.storeName) {
        return this.$pushNotification.error("Please fill store name field");
      }
      if (!this.createStore.domain) {
        return this.$pushNotification.error("Please fill store domain field");
      }

      if (this.createStore.domain.length > 63) {
        this.isErrorDomainName = true;
        return this.$pushNotification.error(
          "Domain cannot be more than 63 characters"
        );
      }
      if (!this.subDomain) {
        return this.$pushNotification.error("Please choose subdomain");
      }
      const body = {
        storeName: this.createStore.storeName,
        domain: this.createStore.domain + "." + this.subDomain,
        domainId: this.domain._id,
        slug: this.createStore.domain,
        productId: this.tempProduct._id,
        supportEmail: this.domain.supportEmail,
      };
      this.loading = true;
      await this.$api.store.create(body);
      this.$store.dispatch("sellerStore/onGetListStore", { ctx: this });
      this.$pushNotification.success("Create store success");
      this.listProductAdmin = false;
      this.$router.push("/seller/store");
      this.onCloseDialog();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  checkPath = this.$route.fullPath;
  mounted() {
    const password = localStorage.getItem("passProduct");
    if (password === "ztech@2022zshop") {
      this.$store.commit("product/checkIsCorrectPassword", true);
      this.onGetDomain();
      this.onGetProductList();
    }
  }

  password = "";
  isHidePassword = false;
  get isCorrect() {
    return this.$store.state.product?.isCorrect || false;
  }

  onSetPassword() {
    if (!this.password)
      return this.$pushNotification.error("Please enter password");
    if (this.password === "ztech@2022zshop") {
      this.$store.commit("product/checkIsCorrectPassword", true);
      localStorage.setItem("passProduct", this.password);
      this.onGetDomain();
      this.onGetProductList();
    } else {
      return this.$pushNotification.error("Incorrect password");
    }
  }

  @Watch("config.page")
  changedPage() {
    this.onGetProductList();
  }

  @Watch("createStore.domain")
  changedValue(value: string) {
    if (value.length > 63) {
      this.isErrorDomainName = true;
    } else {
      this.isErrorDomainName = false;
    }
  }
}
</script>

<style src="./style.scss" lang="scss" scoped></style>
<style lang="scss" scoped>
.name-input {
  max-width: 237px;
  width: 100%;
  background: white;
  border-radius: 6px;

  @media (max-width: 640px) {
    max-width: 100%;
    margin-bottom: 8px;
  }
}

.number-input {
  max-width: 132px;
  width: 100%;
  background: white;
  border-radius: 6px;

  @media (max-width: 640px) {
    max-width: 98%;
  }
}
</style>
